-- this is going to be a big rip with minor changes here and there.  diff get ready.

require 'base.scripts.oop'
require 'base.scripts.vec'
require 'base.scripts.blend'			-- for Renderable

_entClasses = {}
-- for engine class registration.  for collision sameclass and for networking
function entclass(...)
	local cl = class(...)
	--engine-bound.  we'll use this for same-class collision and sending thru network for client-side class-based scripting
	registerEntClass(cl)
	cl.createNetTable = netTableCreate

	_entClasses[cl._entClassID] = cl
	return cl
end

-- here's part of a messy system I need to fix ...

-- not used but it looks useful
-- well ... i kinda set up all named ents in _G, the global array, so this is a bit redundant ...
namedEnts = {}
setmetatable(namedEnts, {
	-- reading: just get back the ent with the name.  this doesn't need to be c-coded. i guess it makes it faster.
	__index = function(self, param) return _ents[entNamed(param)] end;
	-- writing: not yet.  but when we have it, set the ent in the table and set its name.
	__newindex = function(self, param, value) assert(false, 'no writing to the namedEnts table') end;
})

-- works just like namedEnts except it spawns it if its not there
-- not ever really used
spawnEnts = {}
setmetatable(spawnEnts, {
	__index = function(self, param) return _ents[spawn(param)] end;
	__newindex = function(self,key,value) assert(false, 'no writing to the spawnEnts table') end;
})

-- helper for spawntype generation

function Spawnable(classobj, desc, group, bbox)
	local scriptname = classobj.classname
	-- if params aren't provided then use class objects
	if not group then group = classobj.animGroup end
	if not bbox then bbox = classobj.bbox end
	if not desc then
		-- use classobj.spawnParams only if it wasn't inherited (because ctor and spawnDesc do the recursion here)
		if not classobj.super or classobj.spawnParams ~= classobj.super.spawnParams then
			desc = classobj.spawnParams
		end
	end
	
	-- if class objects aren't provided either then use some absolute defaults
	if not group then group = 'marker' end
	if not bbox then bbox = box2:new(.5) end

	if type(desc) == 'table' then
		-- build a string of all parameters
		local nd = ''
		for k,v in pairs(desc) do
			-- for hack override the spawnobj read, we make the spawnParams' value into a table
			-- entry [1] holds the desc, entry [2] holds the code
			if type(v) == 'table' then v = v[1] end
			nd = nd .. '\t' .. k .. ': ' .. v .. '\n'
		end
		desc = nd	--replace
	elseif type(desc) == 'string' then
		desc = desc .. '\n'
	end
	if desc then desc = tostring(desc) else desc = '' end	--if its nil then '' it.  otherwise cast to string
	desc = classobj.classname .. ':\n' .. desc
	if classobj.super then
		desc = desc .. classobj.super.spawnDesc
	end
	
	spawnType(scriptname, {
		group = group,
		bbox = bbox.min[1] .. ' ' .. bbox.min[2] .. ' ' .. bbox.max[1] .. ' ' .. bbox.max[2],
		desc = desc,
		spawnfunc = function(so) return classobj:new(so) end,
	})
	-- hold on to it for later appending by the editor
	classobj.spawnDesc = desc
end

-- server-based entity array to hold all extra script data
-- would it be faster to do all in lua? 
-- wouldn't that eliminate the dependency on the __newindex for inheritence?

_ents = {}

-- thought i would make an entity iterator

function entIterFunc(s, var)
	local i = s.i + 1
	s.i = i
	if i < 0 or i >= entGetCount() then return nil end
	return _ents[entGetIndex(i)]
end

-- i could just as easily use ipairs(_ents) you know ...
function allents()
	-- f is the function we call from here on out
	local f = entiterFunc
	-- s is the state objevt
	local s = {i=-1}
	-- var is the value returned (what about key/value pairs?)
	local var = nil
	--return
	return entIterFunc, s, var
end


-- now we build the class net tables ...
-- netTableCreate( 'Renderable'
-- dirty hack for the time being:
net = {}
setmetatable(net, {
	__index = function(self, param) return netTable(param) end;
	-- writing is no longer necessary - all automated
	__newindex = function(self, param, value) netTable(param, value) end;
})

persist = {}
setmetatable(persist, {
	__index = function(self,param) return sessionVar(param) end;
	__newindex = function(self,param,value) sessionVar(param, value) end;
})

----------------------- base classes ----------------------- 

--[[ i'm removing engine bindings altogether to see if its any faster
Entity
	active = entActive;
	spawnobj = entSpawnObj;
	pos = entPos;
	entClassID = entEntClassID;
	nextthink = entNextThink;
	layer = entLayer;
Renderable	
	group = animAnimGroup;
	seq = animAnimSeq;
	idleseq = animAnimIdleSeq;
	absFrame = animAnimAbsFrame;
	angle = animAngle;
	scale = animScale
	color = animColor
	frame = animFrame;
	frameNextTime = animFrameNextTime;
	frameLastTime = animFrameLastTime;
	left = animLeft;
	blend = animBlend;
Collidable
	bbox = colBBox
	vel = colVel
	contactTile = colContactTile
	contactNormal = colContactNormal
	contactEnt = colContactEnt
	ignoreCollider = IgnoreCollider
	contactTime = colContactTime;
	ignoreEnts = colIgnoreEnts;		-- USED TO BE collIgnoreEnts;
	ignoreWorld = colIgnoreWorld;	-- USED TO BE collIgnoreWorld;
	touchOnly = colTouchOnly		-- USED TO BE collTouchOnly;
	diffClass = colDiffClass		-- USED TO BE collDiffClass;
	noPhysics = colNoPhys;
	useGravity = colUseGravity;
	rotation = colRot;
	massInv = colMassInv;
	restitution = colRestitution;
	friction = colFriction;

--]]

local function addGetSet(classobj, args)
	for key,value in pairs(args) do
		classobj['get'..key] = value
		classobj['set'..key] = value
	end
end

-- return a function that returns a table for getset
local function getsetvec2(name)
	return {
		[name] = name..'Table';
		[name..'X'] = name..'X';
		[name..'Y'] = name..'Y';
	}
end

local function getsetvec4(name)
	return {
		[name] = name..'Table';
		[name..'X'] = name..'X';
		[name..'Y'] = name..'Y';
		[name..'Z'] = name..'Z';
		[name..'W'] = name..'W';
	}
end

local function getsetbox2(name)
	return union(
		{[name] = name..'Table'},	-- box2
		getsetvec2(name..'Min'),	-- vec2
		getsetvec2(name..'Max'))	-- vec2
end

local function addGetSetPrefix(classobj, prefix, ...)
	for i,v in ipairs{...} do
		local t = type(v)
		if t == 'string' then
			addGetSet(classobj, {[v] = _G[prefix..v]})
		elseif t == 'table' then
			for k,u in pairs(v) do	-- append our prefix
				v[k] = _G[prefix..v[k]]
			end
			addGetSet(classobj, v)
		else
			assert(false, 'found an unknown type '..t)
		end
	end
end

-- generate a function to be called every ctor that reads in our spawn objects
function SetupSpawnParams(classobj, spawnParams)
	classobj.spawnParams = spawnParams
	-- make sure they exist
	assert(spawnParams)
	-- make sure it's not inherited -- private-me plz
	assert(not classobj.super or spawnParams ~= classobj.super.spawnParams)

	local fs = [[
function temp(classobj, self, so)
	if not so then return end
]]
	local keys = table.new()
	for k,v in pairs(spawnParams) do
		keys:insert(k)
	end
	
	-- cycle through the keys, but don't use an iterator for the spawnParams table
	-- because i'm going to be changing stuff inside of it as I go
	for i,k in ipairs(keys) do
		v = spawnParams[k]
		fs = fs .. [[
	if so.]]..k..[[ then
]]
		if type(v) == 'string' then	-- if its a string then its just the description for the editor
			local readcode = 'so.'..k
			-- if the classobj already has a def then include that in our spawn param desc
			local default = classobj[k]
			if default then
				if type(default) == 'string' or type(default) == 'number' or type(default) == 'boolean' then
					spawnParams[k] = v .. '. default is '..tostring(default)	-- what happens between tostring() and __concat?
					-- if it's a number then make sure our gen func casts it as a number
					if type(default) == 'number' then
						readcode = 'castnumber(' .. readcode .. ')'
					end
				end
			end

			fs = fs .. [[
		self.]]..k..[[ = ]]..readcode..[[
]]
		elseif type(v) == 'table' then
--[[
how should non-standard params be represented?
we need to write into the gen'd function the contents of the accessor method ...
how about just that? the exact code.
--]]
			fs = fs .. v[2]	-- v[1] being the description.  write v[2] in terms of 'self' and 'so'
		else
			assert(false, 'found a strange type when generating spawn parameters')
		end
		fs = fs .. [[
	end
]]
	end
	fs = fs .. [[
end
]]
	exec(fs)
	classobj.readSpawnParams = temp
	temp = nil
end

-- Entity

entclass('Entity')

-- add some engine bindings
addGetSetPrefix(Entity, 'ent',
	'SpawnObj',
	'NextThink',
	'Layer',
	'EntClassID',
	getsetvec2('Pos')
)

-- this engine hook has a special name so it goes here
Entity.isActive = entActive
Entity.serverSendMessage = entServerSendMessage
Entity.clientSendMessage = entClientSendMessage

function Entity:ctor(so, engineClassName)
	self._ptr = newEnt(engineClassName)	-- link back to the engine
	_ents[self._ptr] = self		-- insert into the entity table

	-- _entClassID is read from the class object
	-- entClassID is written back to the engine
	-- make sure the names differ or else the meta indexing will get in the way
	self:setEntClassID(self._entClassID)

	-- Entity ctor code
	self.so = so
	Entity:readSpawnParams(self, so)	-- only call this in a class that explicitly states its spawn params ...
end

	-- default for falling back on super.think
function Entity:think()
	if self.onThinkCallback then
		self:onThinkCallback()
	end
end

--[[
update net info
I'm gonna provide engine callbacks for the engine-bound classes
(that call the parent classes on the C side of things, so no need to call parent functions for these engine-bound classes)
and see what fps that improves us

It'll copy data from the current entity who called this into the current net table
thus removing the need for the entries in the net tables
so I'll have to take those out too

this might cause reciprocations with whoever is referencing the variables that updateNetInfo writes to...
so those will have to be fixed.
--]]
Entity.updateNetInfo = entUpdateNetInfo
	
function Entity:delete()
	-- already deleted
	if not self:isActive() then return end

	-- unlink from script entity array
	-- if _ents[self._ptr] then _ents[self._ptr] = nil end
	-- only do this in one concentrated spot ...
	-- heck, what if we dont do it at all?
	-- then ents would only get unlinked by lua when they were overwritten
	-- lets try this - to do both unlinking and to keep script/engine pointers happy
	
	local sptr = self._ptr
	
	-- will this get eval'd ?  looks like it will ... funny ...
	-- so for locals it must do substitution at the time of creating the function
	--setTimeout( function() _ents[self._ptr]._ptr = -1 _ents[self._ptr] = nil end, 0.1)
	-- maybe we just need to clear the _ptr link back? or clear the class?
	if _ents[sptr] then -- why wouldn't it?
		_ents[sptr].class = nil
		_ents[sptr]._ptr = nil
		_ents[sptr] = nil
	end

	-- engine callback
	entRemove(sptr)
	-- unlink from all further instance methods which would call the engine
	self._ptr = -1
	-- TODO: 'unlinkEnt' inst method in the Entity interface?
end

--[[
i would make this a member variable
but then every subseqent class would get it
and by ctor's recursion i only want this class to get it
we could make a private member variable table ... if you really wanted to?
 for non-inherited member variables?
	..
or we can do a simple object equality test in Spawnable() to see if its an inherited spawnParams or not 
	..
i like the private idea better because during ctor we're gonna cycle through the spawnParams ... same issue of inh.
... but it won't be an issue if we only cycle through spawnParams for classes we specifically inherit them in as well.
--]]
SetupSpawnParams(Entity, {
	-- spawnobj param name = spawntype description string [default = .. default if it exists in the class object]
	pos = {'object position', [[if type(so.pos) == 'string' then self:setPos(readVec2(so.pos)) else self:setPos(vec2:new(so.pos)) end]]};
	onThink = {'callback to execute every frame', 'self.onThinkCallback = _G[so.onThink]'};
})

Spawnable(Entity)
Spawnable(entclass('Waypoint', Entity))

-- Renderable
entclass('Renderable', Entity)

addGetSetPrefix(Renderable, 'anim',
	'AnimGroup',
	'AnimSeq',
	'AnimIdleSeq',
	'AnimFrame',
	'AnimAbsFrame',
	'AnimFrameNextTime',
	'AnimFrameLastTime',
	'Angle',
	'Left',
	'Blend',
	getsetvec2('Scale'),
	getsetvec4('Color')
)

--[[
the idea of changing Renderable.zScale - one var in one loc held by its all-encompassing class - is nice
and to have it reflect its changes in all subclasses simulatenously ...
but atm we project parent classes into their children (and get quite the performance increase)
so changing zScale will only change it for the Renderable class ...
...
unless everyone else makes sure to reference Renderable.zScale rather than self.zScale or classobj.zScale or whatever.
hear that kids? only ref Renderable.zScale
--]]
Renderable.zScale = -1		-- how much the y component contributes to the z index (linear sys)
Renderable.zBias = -1.5		-- z index bias (regardless of y component)

--[[
seq is our special one
well
the engine has seq and idleseq bindings
but in all our scripts its a standard to set them both,
while the exception is to only set one and let the idle loopback
so - we keep idle as it is
but instead we're going to do the following mapping:
	setAnimIdleSeq	[becomes]	setAnimIdleSeq
	setAnimSeq		[becomes]	setAnimIdleSeq + setAnimSeq
	runAnimSeq		[becomes]	setAnimSeq
--]]
Renderable.runAnimSeq = animAnimSeq
Renderable.setAnimSeq = function(...) animAnimIdleSeq(...) animAnimSeq(...) end

function Renderable:ctor(so, engineClassName)
	if not engineClassName then engineClassName = 'Renderable' end
	Renderable.super.ctor(self, so, engineClassName)

	--[[	
	while we're here how about we set an initial group if the class specifies it
	otherwise ... 
	well ... the group would have already been set by the ctor 
	(which calls the engine and runs the Renderable ctor and sets the group)
	this grabs its stuff from the spawn type
	afterwards we will be referring to the spawnobject table for a group
	between the two comes a class based specification
	so here's the priority:
	1) spawn object param (only works for user-defined level param)
	2) class animGroup variable (works for all objects)
	3) class spawn type variable (only works for objects spawned through the map -- required for editor)
	--]]
	-- avoid direct ref of 'group' - for hope of engine bindings later (and for netinfo)
	if self.class.animGroup then self:setAnimGroup(self.class.animGroup) end
	if self.class.scale then self:setScale(self.class.scale) end

	Renderable:readSpawnParams(self, so)

	self:setAnimSeq('idle')
	self:setAnimIdleSeq('idle')
end
	
Renderable.updateNetInfo = animUpdateNetInfo

-- this one is called for remote connection renders
-- its dif than above cuz its dependant upon a net table to send the stuff
-- rather than having access to all the entities
function Renderable.clientUpdate(classObj)
	-- now here's a lot of overhead...
	if not clientDrawRenderable(
			classObj.zBias + classObj.zScale * net.pos[2],
			classObj.shader,
			classObj.postFBO)
	then
		print('Renderable.clientUpdate failed on entity ', net._ptr)
	end
end

SetupSpawnParams(Renderable, {
	angle = { 'in degrees', 'self:setAngle(castnumber(so.angle))' };
	scale = { 'scale in x & y directions', [[if type(so.scale) == 'string' then self:setScale(readVec2(so.scale)) else self:setScale(vec2:new(so.scale)) end]]};
	group = { 'animation group to use', [[
		self:setAnimGroup(so.group)
		local groupname, groupindex
		groupname, groupindex = self:getAnimGroup()
		if groupindex == 0 then
			groupname = tostring(so.group)
			animLoad(groupname,groupname)
			self:setAnimGroup(groupname)
			groupname, groupindex = self:getAnimGroup()
			if groupindex == 0 then
				print('script failed to load group '..groupname)
			else
				print('loaded group '..groupname..' as an override')
			end
		end
]]};
	left = {'flip the sprite', [[if so.left == 'true' then self:setLeft(true) end]] };
})

Spawnable(Renderable)

Renderable:createNetTable{
--[[ Entity. these must be added in all - they should proly be there at first.  They'll also be hardwired like below.
	active = 'bool',
	_ptr = 'int',
	entClassID = 'short',
	pos = 'vec2f',
--]]
--[[ Renderable.  these are written to through the hardwired engine callback in updateNetInfo
	absFrame = 'int',		-- 4 bytes
	angle = 'angle',		-- 2 bytes .. i bet we could reduce this to 12 bits or something
	left = 'bool',			-- 1 byte .. but it only needs 1 bit ...
	scale = 'vec2f',		-- 8 bytes ... that hardly anyone ever uses
	blend = 'uchar',		-- 1 byte, but not many bits are needed
	color = 'color'			-- 4 bytes
--]]
}

-- Collidable
entclass('Collidable', Renderable)
addGetSetPrefix(Collidable, 'col',
	getsetbox2('BBox'),
	getsetvec2('Vel'),
	getsetvec2('ContactTile'),
	getsetvec2('ContactNormal'),
	'ContactEnt',
	'IgnoreCollider',
	'ContactTime',
	'IgnoreEnts',
	'IgnoreWorld',
	'TouchOnly',
	'DiffClass',
	'NoPhysics',
	'UseGravity',
	'Rotation',
	'MassInv',
	'Restitution',
	'Friction')

-- default values
Collidable.restitution = 0
Collidable.massInv = 1
Collidable.useGravity = true
Collidable.bbox = box2:new(.5)
Collidable.touchOnly = false

function Collidable:ctor(so, engineClassName)
	if not engineClassName then engineClassName = 'Collidable' end
	Collidable.super.ctor(self, so, engineClassName)

	-- for the time being, set up defaults (to write back to engine)
	if self.class.restitution then self:setRestitution(self.class.restitution) end
	if self.class.massInv then self:setMassInv(self.class.massInv) end
	if self.class.useGravity then self:setUseGravity(self.class.useGravity) end
	if self.class.bbox then self:setBBox(self.class.bbox) end
	if self.class.touchOnly then self:setTouchOnly(self.class.touchOnly) end
	if self.class.noPhysics then self:setNoPhysics(self.class.noPhysics) end
	if self.class.friction then self:setFriction(self.class.friction) end

	Collidable:readSpawnParams(self, so)	
end

function Collidable:think()
	Collidable.super.think(self)
	if not self:getNoPhysics() then
		updateEntityPhysics(self)	-- engine call!
		-- NOTICE - this method may potentially terminate the entity!
		-- under such a circumstance we would ideally like to jump all the way out of this lua call (longjump? exception?)
	end
end

function Collidable:touch(other)
	if self.onTouchCallback then
		self:onTouchCallback(other)
	end
end

Collidable.updateNetInfo = colUpdateNetInfo

SetupSpawnParams(Collidable, {
	vel = {'initial velocity', [[if type(so.vel) == 'string' then self:setVel(readVec(so.vel)) else self:setVel(vec2:new(so.vel)) end]]};
	bbox = {'bounding box', [[if type(so.bbox) == 'string' then self:setBBox(readBBox(so.bbox)) else self:setBBox(box2:new(so.bbox)) end]]};
	friction = {'surface friction', 'self:setFriction(castnumber(so.friction))'};
	restitution = {'bounce restitution', 'self:setRestitution(castnumber(so.restitution))'};
	mass = {'object mass (say "infinity" for infinite).\n\tzero is dangerous.', [[
		local mass = so.mass
		if mass == 'infinity' or mass == 'inf' then
			self:setMassInv(0)
		else
			self:setMassInv(1/castnumber(so.mass))
		end
]]};
	onTouch = {'callback to run when the object touches another', 'self.onTouchCallback = _G[so.onTouch]'};
	useGravity = {'affected by gravity?',
		'if so.useGravity == "false" or so.useGravity == "0" then self:setUseGravity(false) end'};
})

Spawnable(Collidable)


entclass('TakesDamage', Collidable)

TakesDamage.allowEnemyDeath = true		-- run a typical enemy death function when we run out of health

TakesDamage.health = 0		-- in case no one else has initialized it	
TakesDamage.maxHealth = 10	-- to be per class overridden
	
function TakesDamage:ctor(so, ...)
	TakesDamage.super.ctor(self, so, ...)
	self.maxHealth = self.class.maxHealth	-- class variable
	TakesDamage:readSpawnParams(self,so)
	self.health = self.maxHealth
end

function TakesDamage:takeDamage(other, dmg)
	self.health = self.health - dmg

	-- any callbacks (map, script) between taking the damage and responding ...
	self:onDmg(other, dmg)

	if self.health > 0 then
		self:pain(other, dmg)
	else
		self:death(other, dmg)
	end
end

function TakesDamage:onDmg(other,dmg) end
	
-- default pain function - can be overridden
function TakesDamage:pain(other,dmg) end
	
-- default death function - can be overridden
function TakesDamage:death(other, dmg)
	if not self.allowEnemyDeath then return end
	
	self:setIgnoreEnts(true)
	self:setRotation(720)
	self:setAnimIdleSeq('die')
	self:setAnimSeq('die')
	-- here is where separate think threads would come in handy
	-- we want the collision think to keep going per frame
	-- yet we want the fadeout think to kick in 3 seconds later ...
	-- and we want the intangir think to stop
	-- lets try solving that with our newly found setTimeout ...
	setTimeout( function() self:delete() end, 1)
end

SetupSpawnParams(TakesDamage, {
	health = {'initial health', 'self.maxHealth = castnumber(so.health)'};
	onDmg = {'script callback when damaged', 'self.onDmg = _G[so.onDmg]'};
})

Spawnable(TakesDamage)

-- it was just too useful to put anywhere else
animLoad('particle', 'dot.png')
entclass('Particle', Renderable, {
	ctor = function(self, args)
		Particle.super.ctor(self)
		self.vel = vec2:new(args.vel)
		self.life = args.life
		self.srclife = args.life
		self.srccolor = vec4:new(args.color)
		self:setColor(args.color)
		self:setScale(vec2:new(args.radius * 2))
		self:setPos(args.pos)
		self:setBlend(BLEND.ADD)
		self:setAnimGroup('particle')
	end,
	
	think = function(self)
		Particle.super.think(self)
		local dt = getDeltaTime()
		self:setPos(self.vel * dt + self:getPos())
		self.life = self.life - dt
		if self.life < 0 then self.life = 0 end
		local frac = self.life / self.srclife
		self:setColorW(self.srccolor[4] * frac)
		if self.life == 0 then self:delete() return end
	end,
})

