require 'base.scripts.ents'
require 'base.scripts.text'

-- haha, its an entclass
-- that means it transports across the network
-- someone should fix that i think ...
entclass('FloatingText', Renderable)

FloatingText.defaultLetterSize = vec2:new(16,16):divTo(screenSize)	-- in normalized coordinates
FloatingText.life = 1
	
function FloatingText:ctor(pos, dmg, color, life)
	FloatingText.super.ctor(self)
	
	-- realign the default letter size every time we make a new font
	-- only needs to be done once per viewtile resize but i have no way of detecting that
	local camera = viewGetBox()
	FloatingText.defaultLetterSize:set(16):divTo(screenSize):mulTo(camera:size())

	self:setPos(pos)
	self.dmg = dmg
	if color then self:setColor(color)
	else self:setColor{10,10,10,1}
	end
	if life then self.life = life end
	self.endTime = getTime() + self.life
end
	
function FloatingText:think()
	FloatingText.super.think(self)
	self:setPosY(self:getPosY() - getDeltaTime())
	if getTime() > self.endTime then
		self:delete()
	end
end

	-- gotta pass the damage string across somehow ...
function FloatingText.clientUpdate(classObj)
	-- don't do super.  i don't want to draw anything
	-- whats your damage
	drawText{
		pos=net.pos;
		size=classObj.defaultLetterSize;
		color=vec4:new(net.color);
		blend=BLEND.DECAL;
		str=tostring(net.dmg);
	}
end

FloatingText:createNetTable{
	dmg = 'float';
}
