require 'bomberman.scripts.player'

entclass('PlayerAI', Player)

--[[
how should the player ai work?

objectives:
	survive
		avoid bomb detonations
	kill other players
		plant bombs near them
			get to them
				bomb breakable blocks to clear a path to them
		get items to better power your bombs
			bomb breakable blocks to potentially get items

GAH i wanna use a RNN for this ... badly .. or some lienar system deal.

simple procedure:
1) find a block
2) plant a bomb by it
3) walk clear
4) wait for detonation
--]]

PlayerAI.MOVESTATE= {
	search = {
		think = function(self)
			local start = {pos = vec2:new(self:getPos())}
			local closest
			local search = table.new{start}
			local total = table.new{start}
			while #search > 0 do
				local cur = search[1]
				for k,v in ipairs{{1,0},{-1,0},{0,1},{0,-1}} do
					local newpos = vec2:new{cur.pos[1] + v[1], cur.pos[2] + v[2]}

					-- make sure we didn't come from here
					local backtrack = false
					for j,t in ipairs(total) do
						if vec2.distSq(t.pos, newpos) < .4*.4 then
							backtrack = true
						end
					end
					if not backtrack then	-- oh continue, where did you go?
						if mapGetType(unpack(newpos)) ~= MAPTYPE.Solid then
							local hit
							for e in allents() do
								if vec2.distSq(e:getPos(), newpos) < .4*.4 then
									-- if it blocks collisions with this ent ...
									-- hack for now
									if e:isa(Bomb) then
										hit = true
										break
									end
									if e:isa(Break) and not e.hitTime then
										closest = e
										break
									end
								end
							end
							if not hit then
								if closest then break end	-- then that's our target.
								-- keep going
								local newloc = {pos=newpos, last=cur}
								search:insert(newloc)		-- current queue
								total:insert(newloc)
							end
						end
					end
				end
				if closest then break end
				search:remove(1)	-- only remove it here so its still there if we found our end
			end
			if #search then
				-- now we can trace back from search[#search] on down the 'last' chain
				local cur = search[1]
				local next = nil
				local first = nil
				while cur do
					cur.next = next
					next = cur
					first = cur
					cur = cur.last
				end
				self.path = first
				-- only need to move if we get a path
				-- if we don't get a path then we should camp for a while or something
				if not first then
					self:setNextThink(getTime()+math.random())
				else
					self.state = self.MOVESTATE.nextMove
				end
			end
		end;
	};
	nextMove = {
		think = function(self)
			if not self.path then
				--self.state = self.MOVESTATE.search
				print('i lost my path')
				self.state = nil
				return
			end

			local cur = self.path 	-- get the path
			local pos = cur.pos	-- get its pos

			local distSq = vec2.distSq(pos, self:getPos())

			-- now move to the position
			if distSq < .04 then
				self.path = cur.next	-- and pop it off the front
				if self.path then self.path.prev = nil end	-- disconnect
				cur.prev = nil
				cur.next = nil

				-- if we're there then plant our bomb and run to safety
				if not self.path then
					-- switch states:
					-- now we do a search for a tile outside the bomb's range
					self:setBomb()
					self.state = nil
					return
				end
			else
			-- still moving towards it:
				local d = pos - self:getPos()
				local ad = vec2:new(d):abs()
				if ad[1] > ad[2] then
					if d[1] < 0 then self.moveCmd = SIDE.LEFT
					else self.moveCmd = SIDE.RIGHT
					end
				else
					if d[2] < 0 then self.moveCmd = SIDE.UP
					else self.moveCmd = SIDE.DOWN
					end
				end
			end
		end;
	};
}

-- start state
PlayerAI.state = PlayerAI.MOVESTATE.search

function PlayerAI:processInput()

	-- dijkstra starting at our present location
	-- until we hit a block
	-- then seek and destroy
	if self.state and self.state.think then self.state.think(self) end
end

