require 'bomblo.scripts.base'
require 'bomblo.scripts.player'

animLoad('money', 'money.png')

entclass('Money', Base)

Money.animGroup = 'money'
Money.bbox = box2:new(.4)
Money.shots = 0

Money.isBlocking = false

function Money:ctor(so)
	Money.super.ctor(self,so)
	Money:readSpawnParams(self,so)
end

function Money:endPush(who, where)
	if not who:isa(Player) then return end

	-- only if we step exactly on it
	if (where - self:getPos()):lenLInf() >= 0.5 then return end
	
	-- give the user our shots
	who:addNumShots(self.shots)

	-- remove self
	self:delete()

	-- see if any are left - if not then open the (first) chest (we find)
	
	local chest = nil
	local moneysLeft = false
	
	-- see if there's any moneys left
	for i,e in pairs(_ents) do
		if e:isa(Money) then
			moneysLeft = true
		elseif e:isa(Chest) then
			chest = e
		end
	end

	if not moneysLeft then
		if not chest then print('you need a chest in a lolo level!') end
		chest:open()
	end
end

-- associated spawntypes.  base and presets.

SetupSpawnParams(Money, {
	shots = 'number of shots given to the player';
})

Spawnable(Money)
Spawnable(entclass('Money1Shot', Money, { shots = 1}), 'defaults to 1 shot')
Spawnable(entclass('Money2Shot', Money, { shots = 2}), 'defaults to 2 shots')
