require 'base.scripts.ents'

animLoad('leveldoor', {sprites = {{file='door.png',bbox={-.5,-1.5,.5,.5}}}})

--maybe this should have no image in-game?
entclass('LevelDoor', Collidable)

LevelDoor.animGroup = 'leveldoor'
LevelDoor.bbox = box2:new(-.5, -1.5, .5, .5)
LevelDoor.name = ''	-- always give a name.  even if its blank
LevelDoor.zBias = -1.3

function LevelDoor:ctor(so,...)
	LevelDoor.super.ctor(self,so,...)
	self:setTouchOnly(true)	-- run touch function, don't react		-- huh, this gives us an infinite loop . . .n.g.
	LevelDoor:readSpawnParams(self,so)
	if not self.level then print('YOU CREATED A LEVELDOOR WITHOUT A LEVEL PARAMETER!') end
end
	
function LevelDoor:touch(other)
	LevelDoor.super.touch(self, other)
	if other and other:isa(Player) then
		if other.input.key.down.isPressed then
			-- go through the door and kill our touch function (just in case - only run it once (within an epsilon))
			-- save all player states here
			-- sessionVar(...)
			-- then save our doorcode name
			persist.destdoorname = self.name
			-- then load up the level
			loadWorld(self.level)
		end
	end
end

SetupSpawnParams(LevelDoor, {
	name = 'unique inter-level identifier';
	level = 'what level to switch to';
})

Spawnable(LevelDoor)