-- for lettuce goat and wolf
require 'base.scripts.ents'

entclass('FollowEntity', Collidable)
FollowEntity.FOLLOW = enum{'STANDING','WALKING'}
function FollowEntity:ctor(so)
	FollowEntity.super.ctor(self, so)
	self:setIgnoreEnts(true)
	self:setRestitution(0.7)
	self:setFriction(0.5)
end
FollowEntity.followBounceForce = 10
function FollowEntity:touch(other)
	FollowEntity.super.touch(self,other)
	if self:getContactNormalY() < -.5 then
		self:setVelY(-self.followBounceForce)
		if not self.followLeader then
			self:setVelX(self:getVelX() * .5)	-- SLOW DOWN
		end
	end
end
FollowEntity.followDist = 1.5
function FollowEntity:think()
	FollowEntity.super.think(self)

	if self.followLeader then
		-- follow the player around
		-- until the next scene
		--
		-- maybe it'd be best to track their last position and
		-- fly through walls or something so we dont always ever get stuck?
		-- or do so if they get too far away?
		if self.followLeader:getPosX() < self:getPosX() - self.followDist then
			self:setVelX(-10)
			self:setLeft(true)
			self.followStatus = self.FOLLOW.WALKING
		elseif self.followLeader:getPosX() > self:getPosX() + self.followDist then
			self:setVelX(10)
			self:setLeft(false)
			self.followStatus = self.FOLLOW.WALKING
		else
			self:setVelX(0)
			self.followStatus = self.FOLLOW.STANDING
		end
	end
end

-- this makes me think takesdamage ...
function FollowEntity:death()
	self:setAngle(180)
	self:setColor{1,0,0,1}
	self:setAnimSeq('die')
	self:setIgnoreEnts(true)
	self.think = function(self) FollowEntity.super.think(self) end	-- skip behavior
end
