-- so much of this is parallel to mario that its sick
-- consider superclassing

require 'data.scripts.jumpenemy'
require 'data.scripts.weapons'

animLoad('megaman', {
	sprites = {
		{file='megaman/stand1.tga',bbox={-.75,-1.5,.75,.5}};	-- 1 = stand1
		{file='megaman/stand2.tga',bbox={-.75,-1.5,.75,.5}};	-- 2 = stand2
		{file='megaman/jump.tga',bbox={-.75,-1.5,.75,.5}};		-- 3 = pain / jump
		{file='megaman/run1.tga',bbox={-.75,-1.5,.75,.5}};		-- 4 = run1 / die
		{file='megaman/run2.tga',bbox={-.75,-1.5,.75,.5}};		-- 5 = run2
		{file='megaman/run3.tga',bbox={-.75,-1.5,.75,.5}};		-- 6 = run3
		{file='megaman/shoot.tga',bbox={-.75,-1.5,.75,.5}};		-- 7 = attack
	};
	seqs = {
		idle = {
			{joint=1; time=0; sprite=1};
			{joint=1; time=10; sprite=2};		--blink
			{joint=1; time=10.1; sprite=1};
		};
		pain = {{joint=1; time=0; sprite=3}};
		run = {
			{joint=1; time=0; sprite=4};
			{joint=1; time=.1; sprite=5};
			{joint=1; time=.2; sprite=6};
			{joint=1; time=.3; sprite=5};
			{joint=1; time=.4; sprite=4};
		};
		jump = {{joint=1; time=0; sprite=3}};
		attack = {{joint=1; time=0; sprite=7}};
		die = {{joint=1; time=0; sprite=4}};
	};
})

entclass('Megaman', JumpEnemy, {
	animGroup = 'megaman';
	bbox = box2:new(-.45, -1.45, .45, .45);
	maxHealth = 150,
	attackFinished = -100,		-- needed for weapons

	death = function(self,other, damage)
		Megaman.super.death(self, other, damage)
		self.state = self.STATE.DIE
	end,

	doAttack = function(self)
		if not self.enemy then return end
		if self.attackFinished >= getTime() then return end
		
		local dir = (vec2:new(self.enemy:getPos()) - self:getPos()):unit()
		weaponBombs.attackFunc(self, dir)		-- run the WEAPON_BOMB attack function
		self.attackFinished = getTime() + weaponBombs.attackDelay
	end,
	
	run = function(self)
		Megaman.super.run(self)
		if math.random(32) == 32 then
			self:doAttack()
		end
	end,
})

Spawnable(Megaman)
