require 'base.scripts.ents'

-- enemy that walks back and forth, turning around at obstacles 
-- the velocity is also renormalized and left/right sprite orientation is recalculated on updates
-- also, default player damage-on-touch is added
entclass('WalkEnemy', TakesDamage, {

	-- this isnt used is it?
	speed = 5,

	touch = function(self, other)
		WalkEnemy.super.touch(self,other)
		-- if the collision was on the side
		if self:getContactNormalX() < -0.7 or self:getContactNormalX() > 0.7 then
			if self:getContactNormalX() > 0.7 then
				self:setVelX(self.speed)
			elseif self:getContactNormalX() < -0.7 then
				self:setVelX(-self.speed)
			end
			-- do dmg to player
			if other and other:isa(Player) and other.health > 0 then
				other:takeDamage(self, 10) 
			end
		end
	end,
	
	think = function(self)
		WalkEnemy.super.think(self)
		
		-- needed for any whose parent think() might kill themselves (Collidable)
		-- TODO FIX THIS: put all deleted ents on a chain and remove them in one spot only.
		if not self:isActive() then return end
		if self:getIgnoreEnts() then return end
		
		--renormalize velocity
		if self:getVelX() < 0 then
			self:setVelX(-self.speed)
			self:setLeft(true)
		else
			self:setVelX(self.speed)
			self:setLeft(false)
		end
	end,
})