require 'lolo.scripts.base'
require 'lolo.scripts.player'

animLoad('heart', 'heart.png')

entclass('Heart', LoloBase)

Heart.animGroup = 'heart'
Heart.bbox = box2:new(.4)
Heart.shots = 0

Heart.isBlocking = false

function Heart:ctor(so)
	Heart.super.ctor(self,so)
	Heart:readSpawnParams(self,so)
end

function Heart:endPush(who, where)
	if not who:isa(Player) then return end

	-- only if we step exactly on it
	if (where - self:getPos()):lenLInf() >= 0.5 then return end
	
	-- give the user our shots
	who:addNumShots(self.shots)

	-- remove self
	self:delete()

	-- see if any are left - if not then open the (first) chest (we find)
	
	local chest = nil
	local heartsLeft = false
	
	-- see if there's any hearts left
	for i,e in pairs(_ents) do
		if e:isa(Heart) then
			heartsLeft = true
		elseif e:isa(Chest) then
			chest = e
		end
	end

	if not heartsLeft then
		if not chest then print('you need a chest in a lolo level!') end
		chest:open()
	end
end

-- associated spawntypes.  base and presets.

SetupSpawnParams(Heart, {
	shots = 'number of shots given to the player';
})

Spawnable(Heart)
Spawnable(entclass('Heart1Shot', Heart, { shots = 1}), 'defaults to 1 shot')
Spawnable(entclass('Heart2Shot', Heart, { shots = 2}), 'defaults to 2 shots')
