require 'wellstory.scripts.states'

entclass('KoolAidJuice', Collidable)


function KoolAidJuice:ctor(so)
	--
end

animLoad('koolaid', 'koolaid/koolaid.anim')

entclass('KoolAid', StateEnt)

KoolAid.animGroup = 'koolaid'
KoolAid.bbox = box2:new(1.95)


KoolAid.STATE = {}

--[[
wait for the player to enter into the scene then start us off
should this be done on the same thread or on a slightly idle thread?
--]]
KoolAid.STATE.WAIT = {}
function KoolAid.STATE.WAIT:think()
	-- if we can see a player then do something cool
	for other in allents() do
		-- todo - distance check
		-- better yet just use a bsp tree or something and check for close leaves
		-- or whatever, for performance's sake
		if other
		and other:isa(Player)
		and other.health > 0
		and vec2.distSq(other:getPos(),self:getPos()) < 7*7
		then
			self.enemy = other
			-- dialog prompt uses sleep, so better fork it
			-- otherwise the whole app locks up in fork errors
			-- come to think of it, why isn't all my lua code run on separate "lua-threads" ?
			fork(function()
				other.disableInput = true
				other:dialog("I'LL SWALLOW YOUR SOUL")
				other.disableInput = false
			end)
			self:setState(self.STATE.RUN)
			return true
		end
	end
end
		
-- start us off.  transition state
KoolAid.STATE.RUN = {}
function KoolAid.STATE.RUN:think()
	self:setState(self.STATE.SHUFFLE)
end

-- shuffle feet back and forth to be gay
KoolAid.STATE.SHUFFLE = {}
function KoolAid.STATE.SHUFFLE:touch(other)
	if not other and self:getContactNormalY() < -.7 then
		self:setVelY(-self.bounceSpeed)
	end
end
function KoolAid.STATE.SHUFFLE:think()
	local t = getTime() - self.stateTime
	self:setVelX(self.shuffleSpeed * math.sin(math.pi * 2 * t / self.shufflePeriod))
	if t > self.shuffleDuration then 
		self:setState(self.STATE.SPRAY)
	end
end

KoolAid.STATE.SPRAY = {}
function KoolAid.STATE.SPRAY:think()
	-- stop walking
	self:setVelX(0)
	-- and spit out kool aid
	KoolAidJuice:new(self)
end

	
KoolAid.shuffleDuration = 3	-- seconds
	
KoolAid.bounceSpeed = 10
KoolAid.shuffleSpeed = 5
KoolAid.shufflePeriod = 5

function KoolAid:ctor(...)
	KoolAid.super.ctor(self,...)
	self:setState(self.STATE.WAIT)

	-- can we remove-self here? or does that belong in our think state?
	if persist.koolaidIsDead then
		self.think = function() end
		setTimeout( function() self:delete() end, 0)
	end
end

function KoolAid:death(other)
	persist.koolaidIsDead = 'true'
	KoolAid.super.death(self,other)
end

function KoolAid:touch(other)
	KoolAid.super.touch(self,other)
	if not self:isActive() then return end
	if other and other:isa(Player) and other.health > 0 then
		other:takeDamage(self,1)
	end
end

Spawnable(KoolAid, 'OHHH YEAHHHH!!!')

